# -*- coding: utf-8 -*-
"""
Created on Wed Oct 18 2017
Modified on July 20 2020

@author: johana
"""
import time
import subprocess
from osbrain import NSProxy
from definitions import *

# Number of samples
SAMP = 20
# Time per sample
TPSA = 23
# Total time of execution of the subprocess
TTOT = int(SAMP*TPSA) + 80
# Number of agents on the MAS.
NAG = 5

# Execution of the Multi-agent server
def run():
    ns = run_nameserver()
    ns = NSProxy(nsaddr=ns.addr())
    
    #--------------------------Main Processes execution
    procA1 = subprocess.Popen(["/usr/bin/python3", "Agent1.py"])
    if (NAG > 1):
        procA2 = subprocess.Popen(["/usr/bin/python3", "Agent2.py"])
        if (NAG > 2):
            procA3 = subprocess.Popen(["/usr/bin/python3","Agent3.py"])
            if (NAG > 3):
                procA4 = subprocess.Popen(["/usr/bin/python3","Agent4.py"])
                if (NAG > 4):
                    procA5 = subprocess.Popen(["/usr/bin/python3","Agent5.py"])
                else:
                    print('More than 5 agents are required')
    
    # Wait establish communications and print to verify connections
    time.sleep (5)
    #for alias in ns.agents():
    #    print(alias)
    #--------------------------Extract socket addresses from server to evaluate conection
    flag = True
    while flag:
        try:
            one = ns.proxy('A1')
            print('agent one online')
            break
        except:
            print('Try again, agent one')
    if (NAG > 1):
        while flag:
            try:
                two = ns.proxy('A2')
                print('agent two online')
                break
            except:
                print('Try again, agent two')
        if (NAG > 2):
            while flag:
                try:
                    three = ns.proxy('A3')
                    print('agent three online')
                    break
                except:
                    print('Try again, agent three')
            if (NAG > 3):
                while flag:
                    try:
                        four = ns.proxy('A4')
                        print('agent four online')
                        break
                    except:
                        print('Try again, agent four')
                if (NAG > 4):
                    while flag:
                        try:
                            five = ns.proxy('A5')
                            print('agent five online')
                            break
                        except:
                            print('Try again, agent five')
                else:
                    print('There are no more than 5 agents in this example')

    # --------------------------Communication links

    if (NAG > 1):
        # Communication link between agent one and two
        one.connect(two.addr('main'), handler='message_S2')
        two.connect(one.addr('main'), handler='message_S1')

        if (NAG > 2):
            # Communication link between agent three, and one and two
            one.connect(three.addr('main'), handler='message_S3')
            two.connect(three.addr('main'), handler='message_S3')
            three.connect(one.addr('main'), handler='message_S1')
            three.connect(two.addr('main'), handler='message_S2')

            if (NAG > 3):
                # Communication link between agent four, and one, two and three
                one.connect(four.addr('main'), handler='message_S4')
                two.connect(four.addr('main'), handler='message_S4')
                three.connect(four.addr('main'), handler='message_S4')
                four.connect(one.addr('main'), handler='message_S1')
                four.connect(two.addr('main'), handler='message_S2')
                four.connect(three.addr('main'), handler='message_S3')

                if (NAG > 4):
                    # Communication link between agent Five and one, two, three and four
                    one.connect(five.addr('main'), handler='message_S5')
                    two.connect(five.addr('main'), handler='message_S5')
                    three.connect(five.addr('main'), handler='message_S5')
                    four.connect(five.addr('main'), handler='message_S5')
                    five.connect(one.addr('main'), handler='message_S1')
                    five.connect(two.addr('main'), handler='message_S2')
                    five.connect(three.addr('main'), handler='message_S3')
                    five.connect(four.addr('main'), handler='message_S4')

                    # Communication link of control from agent leader five.
                    one.connect(five.addr('control'), handler='message_RS')
                    two.connect(five.addr('control'), handler='message_RS')
                    three.connect(five.addr('control'), handler='message_RS')
                    four.connect(five.addr('control'), handler='message_RS')

    ##---------------------------------------------------
    
    for i in range(TTOT): 
        time.sleep (1)
        if i%100 == 0:
            print(i)
    
    # Time to wait for stop every process
    time.sleep(6)
    ns.shutdown()
    
inicio = time.time()
run()
point = time.time()
delta = point - inicio
print('Time in test is '+str(delta)+' s')