"""
Created:    Nov 23/2017 Thu
Modified:   Feb 13/2018 Thu
@utor: Johana
Training file - One output/ DB cases
"""

from __future__ import print_function
import neat
import visualize
import numpy as np
import gzip
import pickle
import fileinput
import time

#--------------------------------------------------------------Global Variables
FEA1 = 60
FEA2 = 44
FEA3 = 30
FEA4 = 20
SAMPLES = 200
NGEN1 = 70 #80
NGEN2 = 100 #200
NBT = 10 #10
MNAG = 6 #6
MCOL = max(FEA1,FEA2,FEA3,FEA4)+1
INFO = np.zeros([SAMPLES,MCOL])
TEST = np.zeros([SAMPLES,MCOL])
ALLD = np.zeros([SAMPLES,MCOL])
INP = 0
INICIO = 0
FINAL = 0
NAMEIM = ''
DATAB  = ''
PRE = ''
SNET = 'NET/'
PRO = np.array([[0.1,0.3,0.3,0.3],[0.4,0.2,0.2,0.2],[0.7,0.1,0.1,0.1],[0.3,0.1,0.3,0.3],[0.2,0.4,0.2,0.2],[0.1,0.7,0.1,0.1],
               [0.3,0.3,0.1,0.3],[0.2,0.2,0.4,0.2],[0.1,0.1,0.7,0.1],[0.3,0.3,0.3,0.1],[0.2,0.2,0.2,0.4],[0.1,0.1,0.1,0.7],
               [0.1,0.1,0.4,0.4],[0.1,0.4,0.1,0.4],[0.1,0.4,0.4,0.1],[0.4,0.1,0.1,0.4],[0.4,0.1,0.4,0.1],[0.4,0.4,0.1,0.1],
               [0.2,0.2,0.3,0.3],[0.2,0.3,0.2,0.3],[0.2,0.3,0.3,0.2],[0.3,0.2,0.2,0.3],[0.3,0.2,0.3,0.2],[0.3,0.3,0.2,0.2]])


# ------------------------------------------------Functions to train the system
def eval_genomes(genomes, config):
    for genome_id, genome in genomes:
        net = neat.nn.FeedForwardNetwork.create(genome, config)
        #net = neat.nn.RecurrentNetwork.create(genome, config)
        uncfit=1
        tam=INFO.shape
        for j in range(tam[0]):
            pos=()
            for i in range (INICIO,FINAL):
                pos = pos + (INFO[j,i],)
            output = net.activate(pos)
            xo = (INFO[j,INP])
            uncfit -= (output[0]-xo)**2
            #print (pos,output[0])
        genome.fitness = uncfit

def runGA(config_file, ngen):
    # Load configuration.
    config = neat.Config(neat.DefaultGenome, neat.DefaultReproduction,
                         neat.DefaultSpeciesSet, neat.DefaultStagnation,
                         config_file)

    # Create the population, which is the top-level object for a NEAT run.
    p = neat.Population(config)

    # Add a stdout reporter to show progress in the terminal.
    p.add_reporter(neat.StdOutReporter(False))
    stats = neat.StatisticsReporter()
    p.add_reporter(stats)

    # Run for up to # generations.
    winner = p.run(eval_genomes, ngen)
    winner_net = neat.nn.FeedForwardNetwork.create(winner, config)
    #winner_net = neat.nn.RecurrentNetwork.create(winner, config))

    generations = len(stats.most_fit_genomes)
    best_fitness = [c.fitness for c in stats.most_fit_genomes]
    return(best_fitness[generations-1],winner_net,config,winner)

def runA(config_file, save_file, ngen):
    result=np.zeros([216,5]) # 216 = 24*3*3
    cases = 0
    for cp in range(24):#24 Table Cases
        for nno in range(3):#3 #Neurons hidden layer
            for iconn in range(3):#3 Type initial connection
                print("Case "+str(cases)+" of  215")
                case_define (config_file, iconn, nno,PRO[cp])
                result[cases,0] = cp
                result[cases,1] = nno
                result[cases,2] = iconn
                inicio = time.time()
                result[cases,4],winner_net,config,winner = runGA(config_file, ngen)
                fin = time.time()
                result[cases,3]=fin-inicio
                if cases == 0:
                    Bgg = result[cases,4]
                    save_net(SNET + 'a'+ save_file,winner)
                else:
                    if result[cases,4] > Bgg:
                        Bgg = result[cases,4]
                        save_net(SNET + 'a'+ save_file,winner)
                cases = cases + 1
    np.savetxt('Cases/'+ PRE + DATAB +'.csv',result,delimiter=',')
    return BBNN(result[:,4]),result

def runB(config_file, save_file, ngen,cp,nno,iconn, times):
    print (cp,nno,iconn)
    tem = PRO[int(cp)]
    case_define (config_file, int(iconn),int(nno),tem)
    data = np.zeros([times,4])
    tam=TEST.shape
    for k in range(times):
        best_fit, win_net,configo,win = runGA(config_file, ngen)
        data[k,0] = best_fit        
        if k==0:
            bestf = best_fit
            winner_net = win_net 
            #config = configo
            winner = win
        else:
            if (bestf < best_fit ):
                bestf = best_fit
                winner_net = win_net 
                #config = configo
                winner = win
        # All data
        err=0
        for m in range(tam[0]):
            pos=()
            for i in range (INICIO,FINAL):
                pos = pos + (TEST[m,i],)
            output = win_net.activate(pos)
            xo=(TEST[m,INP])
            err += (output[0]-xo)**2
        errp=(err/tam[0])
        data[k,1]=err
        data[k,2]=errp
        data[k,3]=tam[0]
    np.savetxt('Cases/'+ PRE + DATAB+'MG.csv',data,delimiter=',')
    save_net(SNET + save_file,winner)
    return winner_net

def draw(config_file, netname):
    # Load configuration.
    config = neat.Config(neat.DefaultGenome, neat.DefaultReproduction,
                         neat.DefaultSpeciesSet, neat.DefaultStagnation,
                         config_file)
    winner = restore_net(netname, config_file, 0)
    print('\nBest genome:\n{!s}'.format(winner))
    winner_net = neat.nn.FeedForwardNetwork.create(winner, config)
    visualize.draw_net(config, winner, False,filename=(NAMEIM+'.svg'))
    save_net(SNET + 'Final_'+ netname,winner_net)

def train(win_net):
    data = np.zeros([3])
    err=0
    tam = INFO.shape
    sal= ([])
    for m in range(tam[0]):
        pos=()
        for i in range (INICIO,FINAL):
            pos = pos + (INFO[m,i],)
        output = win_net.activate(pos)
        xo = (INFO[m,INP])
        err += (output[0]-xo)**2
        sal = np.append(sal, output[0])
    data[0] = err
    data[1] = err/tam[0]
    data[2] = tam[0]
    return data, sal

def test(win_net, typeo = 0):
    data = np.zeros([3])
    err=0
    tam = TEST.shape
    sal= ([])
    for m in range(tam[0]):
        pos=()
        for i in range (INICIO,FINAL):
            pos = pos + (TEST[m,i],)
        output = win_net.activate(pos)
        xo = (TEST[m,INP])
        err += (output[0]-xo)**2
        sal = np.append(sal, output[0])
    data[0] = err
    data[1] = err/tam[0]
    data[2] = tam[0]
    if typeo == 0:
        return data
    else:
        return data, sal
        
def testf(netname,config_file):
    win_net = restore_net(netname, config_file, case=1)
    data = test(win_net)
    print (data)

def testr(netname,config_file):
    tam = ALLD.shape
    win_net = restore_net(netname, config_file, case=1)
    data = np.zeros([5])
    err = 0
    de = 0
    for m in range(tam[0]):
        pos=()
        for i in range (INICIO,FINAL):
            pos = pos + (ALLD[m,i],)
        output = win_net.activate(pos)
        xo = (ALLD[m,INP])
        if m%100 == 0:
            print("Expected output {!r}, got {!r}".format(xo, output))
        err += (output[0]-xo)**2
        if xo == 0:
            if output[0] > 0.5:
                de += 1
        else:
            if output[0] <= 0.5:
                de += 1
    data[0] = de
    data[1] = de/tam[0]
    data[2] = err
    data[3] = err/tam[0]
    data[4] = tam[0]
    print (data)

def restore_net(filename,config_file, case):
    config = neat.Config(neat.DefaultGenome, neat.DefaultReproduction,
                         neat.DefaultSpeciesSet, neat.DefaultStagnation,
                         config_file)
    with gzip.open(filename) as f:
        winner = pickle.load(f)
    winner_net = neat.nn.FeedForwardNetwork.create(winner, config)
    if case == 0:
        return winner
    else:
        return winner_net

def save_net(filename,net):
    with gzip.open(filename, 'w', compresslevel=5) as f:
        pickle.dump(net, f, protocol=pickle.HIGHEST_PROTOCOL)
        
def inputs_define (config_path, num):
    textToSearch = 'num_inputs              = '
    textToReplace ='num_inputs              = '+str(num)+'\n'
    tempFile = open(config_path, 'r+' ) # Read and write
    for line in fileinput.input(config_path):
        if textToSearch in line :
            textToFind=line
    for line in fileinput.input(config_path):
        tempFile.write( line.replace( textToFind, textToReplace ) )
    tempFile.close()

def case_define (config_path, iconn, nhidden,prob):
    if iconn == 0:
        TTRA = 'initial_connection      = unconnected\n'
    if iconn == 1:
        TTRA = 'initial_connection      = full_nodirect\n'
    if iconn == 2:
        TTRA = 'initial_connection      = full_direct\n'
    textToSearchA = 'initial_connection      = '
    textToSearchB = 'num_hidden              = '
    TTRB = textToSearchB + str(nhidden) + '\n'
    textToSearchC = 'conn_add_prob           = '
    TTRC = textToSearchC + str(prob[0]) + '\n'
    textToSearchD = 'conn_delete_prob        = '
    TTRD = textToSearchD + str(prob[1]) + '\n'    
    textToSearchE = 'node_add_prob           = '
    TTRE = textToSearchE + str(prob[2]) + '\n'    
    textToSearchF = 'node_delete_prob        = '
    TTRF = textToSearchF + str(prob[3]) + '\n'
    tempFile = open(config_path, 'r' ) # Read
    for line in fileinput.input(config_path):
        if textToSearchC in line :
            tTFC=line
        if textToSearchD in line :
            tTFD=line
        if textToSearchA in line :
            tTFA=line
        if textToSearchE in line :
            tTFE=line
        if textToSearchF in line :
            tTFF=line
        if textToSearchB in line :
            tTFB=line
    tempFile.close()
    replacements = {tTFA:TTRA, tTFB:TTRB, tTFC:TTRC,tTFD:TTRD, tTFE:TTRE,tTFF:TTRF}
    lines = []
    with open(config_path) as infile:
        for line in infile:
            for src, target in replacements.items():
                line = line.replace(src, target)
            lines.append(line)
    with open(config_path, 'w') as outfile:
        for line in lines:
            outfile.write(line)

def BBNN(data):
    tam=data.shape
    for j in range(tam[0]):
        if j==0:
            pos=j
            dat=data[j]
        else:
            if data[j]>dat:
                pos=j
                dat=data[j]
    return pos

# -------------------Functions to config the inputs files and output file names

def SONARConfig():
    print ("Data base sonar")
    NameConfig='config-C1'
    global INP    
    INP =FEA1;
    NameNet='net-C1-0'
    global NAMEIM
    NAMEIM ='Image_net_C1'
    global DATAB
    DATAB='C1'
    return (NameConfig,NameNet)

def SPECTConfig():
    print ("Data base Heart")
    NameConfig='config-C2'
    global INP    
    INP=FEA2;
    NameNet='net-C2-0'
    global NAMEIM
    NAMEIM ='Image_net_C2'
    global DATAB
    DATAB='C2'
    return (NameConfig,NameNet)

def WDBCConfig():
    print ("Data base breast cancer")
    NameConfig='config-C3'
    global INP    
    INP=FEA3
    NameNet='net-C3-0'
    global NAMEIM
    NAMEIM ='Image_net_C3'
    global DATAB
    DATAB='C3'
    return (NameConfig,NameNet)

def RINGConfig():
    print ("Data base Gaussians")
    NameConfig='config-C4'
    global INP    
    INP=FEA4
    NameNet='net-C4-0'
    global NAMEIM
    NAMEIM ='Image_net_C4'
    global DATAB
    DATAB='C4'
    return (NameConfig,NameNet)

def MGauConfig():
    print ("Data base 3dGaussian")
    NameConfig='config-C5'
    global INP    
    INP=3
    NameNet='net-C5'
    global NAMEIM
    NAMEIM ='Image_net_C5'
    global DATAB
    DATAB='DB_gaussian'
    return (NameConfig,NameNet)

options={1:SONARConfig,
         2:SPECTConfig,
         3:WDBCConfig,
         4:RINGConfig,
         5:MGauConfig}
         
# Selection--------------
def execute(intcas,con,pre):
    pos = 0
    eval_train =([])
    eval_test =([])    
    if intcas == 0: 
        result=([])
        print("************************************Training output Uncertain all cases:")
        pos,result = runA(con[0],pre+con[1],NGEN1)
        print(pos)        
        cp = int(result[pos,0])
        nno = int(result[pos,1])
        iconn = int(result[pos,2])
        print("************************************Training output Uncertain best case:")
        fnet = runB(con[0], pre + con[1], NGEN2, cp , nno, iconn, NBT)
        print("************************************Evaluation of the best case:")
        eval_train, result_train =  train(fnet)
        eval_test, result_test =  test(fnet, typeo = 1)
        np.savetxt('Result/'+ pre + DATAB +'_TD.csv',result_train,delimiter=',')
        np.savetxt('Result/'+ pre + DATAB +'_ED.csv',result_test,delimiter=',')
    elif (intcas == 1 or intcas == 6):
        result = np.genfromtxt('Cases/'+ pre + DATAB +'.csv',delimiter=',')
        pos = BBNN(result[:,4])
        cp = int(result[pos,0])
        nno = int(result[pos,1])
        iconn = int(result[pos,2])
        if intcas == 6:
            numgen = 2*NGEN2 # 200 generations
        else:
            numgen = NGEN2
        print("************************************Training output Uncertain best case:")
        fnet = runB(con[0], PRE + con[1], numgen, cp , nno, iconn, NBT)
        print("************************************Evaluation of the best case:")
        eval_train, result_train =  train(fnet)
        eval_test, result_test =  test(fnet, typeo = 1)
        np.savetxt('Result/'+ PRE + DATAB +'_TD.csv',result_train,delimiter=',')
        np.savetxt('Result/'+ PRE + DATAB +'_ED.csv',result_test,delimiter=',')
    elif intcas == 2:
        print("************************************Test net best case with validate data:")
        print("Select net type (a) or (DT_):")
        tip = input()
        testf(str(tip)+pre+con[1],con[0])
    elif intcas == 3:
        print("************************************Test net best case all and range data:")
        print("Select net type (a) or (DT_):")
        tip = input()
        testr(str(tip)+pre+con[1],con[0])
    elif intcas == 4:
        print("************************************Default train:")
        print("# Generations")
        ng = input()
        bestfit,winner_net,config,winner= runGA(con[0], int(ng))
        save_net(SNET + 'DT_'+pre+con[1],winner)
        data = test(winner_net)
        visualize.draw_net(config, winner, False,filename=(NAMEIM+'.svg'))
        print('\nBest genome:\n{!s}'.format(winner))
        print(data)       
    elif intcas == 5:
       print("************************************Print Uncertain Net:")
       draw(con[0], pre+con[1])
    else:
        print('******Error*****')
    return eval_train, eval_test
#--------------------------------------------------------------------------Main
if __name__ == '__main__':
    evalt_train = ([])
    evalt_test = ([])
    k = 0
    print("DB to train (1-4 Phase one; 5-8 Phase two; 9 only case):")
    db = input()
    if int(db) < 5:
        con = options[int(db)]()
        ALLD = np.genfromtxt('../DB/'+DATAB+'.csv',delimiter=',')
        INFO = np.genfromtxt('../DB/'+DATAB+'_T.csv',delimiter=',')
        TEST = np.genfromtxt('../DB/'+DATAB+'_E.csv',delimiter=',')

        print("Select =")
        print("(0):All cases")
        print("(1):Train the best")
        print("(2):Test with validate data (a/DT_net-...)") 
        print("(3):Test range with all data (a/DT_net-...)") 
        print("(4):Default train")
        print("(5):Only draw red (net-...)")
        print("(6):Reserved Phase two")
        intcas = input()
        intcas = int(intcas)
        
        print ("Number of agents start in:")
        start = int(input())-1
        start = start%7
        
        print ("Agent train begin:")
        begin = int(input())-1
        begin = begin%7
        
        for nagen in range(start,MNAG):
            if begin == 0:
                FINAL = 0
            else:
                FINAL = int((INP/(nagen+1))*(begin))
            for age in range(begin,nagen+1):
                print('*** AGENT of '+DATAB+' :'+str(age+1)+' of '+str(nagen+1)+' agents ****')
                INICIO = FINAL
                FINAL = int((INP/(nagen+1))*(age+1)) 
                PRE = str(nagen+1)+str(age+1)
                inpt = FINAL - INICIO
                inputs_define (con[0], inpt)
                eval_train, eval_test = execute(intcas,con,PRE)
                print('Training data result')
                print(eval_train)
                print('Evaluation data result')
                print(eval_test)
                evalt_train = np.append(evalt_train,[nagen+1,age+1])
                evalt_train = np.append(evalt_train,eval_train)
                evalt_test = np.append(evalt_test,[nagen+1,age+1])
                evalt_test = np.append(evalt_test,eval_test)
                k = k+1
            begin = 0
        evalt_train = np.resize(evalt_train,[k,5])
        evalt_test = np.resize(evalt_test,[k,5])
        np.savetxt('Result/'+ DATAB +'_results_train.csv',evalt_train,delimiter=',')
        np.savetxt('Result/'+ DATAB +'_results_test.csv',evalt_test,delimiter=',')
        
    elif(int(db) >= 5 and int(db) < 9): # Case training cooperative making decision - without long training
        db = int(db)-4
        intcas = 6
        con = options[int(db)]()
        train_base = np.genfromtxt('../DB/'+DATAB+'_T.csv',delimiter=',')
        tamt = train_base.shape
        eval_base = np.genfromtxt('../DB/'+DATAB+'_E.csv',delimiter=',')
        tame = eval_base.shape
        last = INP
        for nagen in range (1,MNAG):
            dataadd = np.zeros([tamt[0],nagen+1])
            testadd = np.zeros([tame[0],nagen+1])
            for i in range (nagen+1):
                PRE = str(nagen+1)+str(i+1)
                dataadd[:,i] = np.genfromtxt('Result/'+PRE + DATAB +'_TD.csv',delimiter=',')
                testadd[:,i] = np.genfromtxt('Result/'+PRE + DATAB +'_ED.csv',delimiter=',')
            term = 0
            start= 0
            INICIO = 0
            for age in range(nagen+1):
                print('*** AGENT '+str(age+1)+' of '+str(nagen+1)+' agents ****')
                prein = str(nagen+1)+str(age+1)
                PRE = 'COOP_'+prein
                start = term
                term = int((last/(nagen+1))*(age+1)) 
                inpta = term - start
                inpt = inpta + nagen + 1
                INP = inpt
                FINAL = inpt
                inputs_define (con[0], inpt)
                
                INFO = np.zeros([tamt[0],inpt+1])
                INFO[:,0:inpta] = train_base[:,start:term]
                INFO[:,inpta:inpt] = dataadd
                INFO[:,inpt] = train_base[:,last]
                
                TEST = np.zeros([tame[0],inpt+1])
                TEST[:,0:inpta] = eval_base[:,start:term]
                TEST[:,inpta:inpt] = testadd
                TEST[:,inpt] = eval_base[:,last]
                
                eval_train, eval_test = execute(intcas,con,prein)
                evalt_train = np.append(evalt_train,[nagen+1,age+1])
                evalt_train = np.append(evalt_train,eval_train)
                evalt_test = np.append(evalt_test,[nagen+1,age+1])
                evalt_test = np.append(evalt_test,eval_test)
                k = k+1
        evalt_train = np.resize(evalt_train,[k,5])
        evalt_test = np.resize(evalt_test,[k,5])
        print(evalt_train)
        print(evalt_test)
        np.savetxt('Result/COOP_'+ DATAB +'_results_train.csv',evalt_train,delimiter=',')
        np.savetxt('Result/COOP_'+ DATAB +'_results_test.csv',evalt_test,delimiter=',')
        
    else:
        db = int(db)-4
        intcas = 0
        
        con = options[int(db)]()
        ALLD = np.genfromtxt('../DB/'+DATAB+'.csv',delimiter=',')
        INFO = np.genfromtxt('../DB/'+DATAB+'_T.csv',delimiter=',')
        TEST = np.genfromtxt('../DB/'+DATAB+'_E.csv',delimiter=',')
        PRE = 'UNC'
        inputs_define (con[0], INP)
        INICIO = 0
        FINAL = INP
        eval_train, eval_test = execute(intcas,con,PRE)
    